﻿using System;
using System.Collections.Generic;
using System.Text;
using fichier1.Model;

namespace fichier1.Controllers
{


    public class GameController : IGameController
    {
        private Partie game;
        public GameController(Partie game)
        {
            this.game = game;
        }

        /// <summary>
        /// Recupere le mot suivant a decouper
        /// </summary>
        /// <returns>Un tableau contenant un string, representant un string pret a etre decoupe</returns>
        public string[] getMotSuivant()
        {
            return game.getMotCourant();
        }

        /// <summary>
        /// Valide le mot et l'envoie au model
        /// </summary>
        /// <param name="mot"></param>
        public void validerMot(string[] mot)
        {
            game.validerMotCourant(mot);
        }

        /// <summary>
        /// Recupere un mot decoupe auparavant
        /// </summary>
        /// <param name="nb">numero du mot a recuperer</param>
        /// <returns>un tableau de string des morceaux de mot decoupes</returns>
        public string[] getMot(int nb)
        {
            return game.getMot(nb);
        }

        /// <summary>
        /// Recupe la correction d'un mot
        /// </summary>
        /// <param name="nb">numero du mot corrige a recuperer</param>
        /// <returns>un tableau de string des morceaux de mot decoupes</returns>
        public string[] getCorrection(int nb)
        {
            return game.getCorrection(nb);
        }

        /// <summary>
        /// Recupere le numero du mot courrant pendant la partie
        /// </summary>
        /// <returns>numero du mot</returns>
        public int getCurrentWordNumber()
        {
            // TODO : implement
            return 0;
        }

        /// <summary>
        /// Recupere le nombre total de mots dans la partie
        /// </summary>
        /// <returns>nombre total de mots</returns>
        public int getTotalWordNumber()
        {
            // TODO: implement
            return 0;
        }
    }
}
