﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using fichier1.Controllers;

namespace fichier1.Views
{
    public partial class ViewDecoupage : UserControl
    {
        private IGameController ctrl;

        private string[] mot;

        public ViewDecoupage(IGameController ctrl)
        {
            InitializeComponent();
            this.ctrl = ctrl;
            this.mot = ctrl.getMotSuivant();
        }

        private void AfficherMot()
        {
            pnlMot.Controls.Clear();
            int decalage = 25;
            int letterIndex = 0;
            for (int i = 0; i < this.mot.Length; i++)
            {
                for (int j = 0; j < this.mot[i].Length; j++)
                {
                    Label lbl = new Label();
                    lbl.Text = this.mot[i].Substring(j, 1);
                    lbl.Width = 10;
                    pnlMot.Controls.Add(lbl);
                    lbl.Left = decalage;
                    decalage += 10;
                    lbl.Click += (sender, e) =>
                    {
                        this.DecouperMot(letterIndex);
                    };
                }
                if (i != this.mot.Length -1)
                {
                    Label lbl = new Label();
                    lbl.Text = " ";
                    lbl.Width = 10;
                    pnlMot.Controls.Add(lbl);
                    lbl.Left = decalage;
                    decalage += 10;
                    lbl.Click += (sender, e) =>
                    {
                        this.RecollerMot(i);
                    };
                }
            }
        }

        private void DecouperMot(int index)
        {
            int i = 0;
            while (i < this.mot.Length && index >= this.mot[i].Length)
            {
                index -= this.mot[i].Length;
                i++;
            }
            if (i < this.mot.Length)
            {
                string[] mot = new string[this.mot.Length + 1];
                int j = 0;
                while (j < i)
                {
                    mot[j] = this.mot[j];
                    j++;
                }
                mot[j] = this.mot[j].Substring(0, index + 1);
                j++;
                mot[j] = this.mot[i].Substring(index + 1);
                j++;
                i++;
                while (i < this.mot.Length)
                {
                    mot[j] = this.mot[i];
                }

                this.mot = mot;
                this.AfficherMot();
            }
        }

        private void RecollerMot(int index)
        {
            if (index < this.mot.Length - 1)
            {
                string[] mot = new string[this.mot.Length - 1];
                for (int i = 0; i < index; i++)
                {
                    mot[i] = this.mot[i];
                }
                mot[index] = this.mot[index] + this.mot[index + 1];
                index++;
                while (index < this.mot.Length - 1)
                {
                    mot[index] = this.mot[index + 1];
                }

                this.mot = mot;
                this.AfficherMot();
            }
        }

        private void btnValider_Click(object sender, EventArgs e)
        {
            this.ctrl.validerMot(this.mot);
        }
    }
}
